
Core - Bug # 44470

Status: Resolved Priority: Must have
Author: Oliver Hader Category: Backend User Interface
Created: 2013-01-11 Assigned To: Oliver Hader
Updated: 2013-10-28 Due date:
TYPO3 Version: 4.5
PHP Version: 5.3
Complexity: easy
Is Regression: No
Sprint Focus:
Subject: Content elements in wrong column in page module
Description

If working on workspaces, it might happen that content elements just appear in the wrong column.
The reason is, that live(!) content elements are selected using a specific column value and then are overlays by workspace data.
If the column value has been modified in a workspace, this is currently just ignored during rendering.

Subtasks:
Bug # 44481: Check for new content element button uses old query object Resolved
Related issues:
related to Core - Bug # 32967: Backend workspace copy/cut paste column conten... Closed 2012-01-04
related to Core - Bug # 43430: Drag and Drop of content elements does not work Accepted 2012-11-29
related to Core - Bug # 39983: Change colPos of content element in draft work... Needs Feedback2012-08-20
related to Core - Bug # 48939: Moving a content down moves it in another column Resolved 2013-06-07
precedes Core - Bug # 47529: Regression in 4.7.11rc1: Invalid argument suppli... Resolved 2013-04-24

Associated revisions
Revision 047b6391 - 2013-01-12 16:51 - Oliver Hader

[BUGFIX] Content elements in wrong column in page module

If working on workspaces, it might happen that content elements
just appear in the wrong column. The reason is, that live(!)
content elements are selected using a specific column value and
then are overlaid with workspace data.

If the column value has been modified in a workspace, this is
currently just ignored during rendering.

Change-Id: I9eccc2ff5b7220544cd28ee6de8f55453c04a5d1
Fixes: #44470
Releases: 6.1, 6.0, 4.7, 4.6, 4.5
Reviewed-on: https://review.typo3.org/17468
Reviewed-by: Jigal van Hemert
Tested-by: Jigal van Hemert

Revision 2abebe67 - 2013-01-12 17:02 - Oliver Hader

[BUGFIX] Content elements in wrong column in page module
If working on workspaces, it might happen that content elements
just appear in the wrong column. The reason is, that live(!)
content elements are selected using a specific column value and
then are overlaid with workspace data.

If the column value has been modified in a workspace, this is
currently just ignored during rendering.

Change-Id: I6669ea096d93269591727b20d92ef5250898900f
Fixes: #44470
Releases: 6.1, 6.0, 4.7, 4.6, 4.5
Reviewed-on: https://review.typo3.org/17496
Reviewed-by: Jigal van Hemert
Tested-by: Jigal van Hemert

Revision f6d0567b - 2013-03-15 18:18 - Jigal van Hemert

[BUGFIX] Content elements in wrong column in page module

If working on workspaces, it might happen that content elements
just appear in the wrong column. The reason is, that live(!)
content elements are selected using a specific column value and
then are overlaid with workspace data.

If the column value has been modified in a workspace, this is
currently just ignored during rendering.

Change-Id: I148ca1b023226f2f99417b3baf238b72346e721f
Fixes: #44470
Releases: 6.1, 6.0, 4.7, 4.6, 4.5
Reviewed-on: https://review.typo3.org/17497
Reviewed-by: Oliver Hader
Tested-by: Oliver Hader

Revision 1da948f9 - 2013-03-15 18:18 - Jigal van Hemert

[BUGFIX] Content elements in wrong column in page module

If working on workspaces, it might happen that content elements
just appear in the wrong column. The reason is, that live(!)
content elements are selected using a specific column value and
then are overlaid with workspace data.

If the column value has been modified in a workspace, this is
currently just ignored during rendering.

Change-Id: I148ca1b023226f2f99417b3baf238b72346e721f
Fixes: #44470
Releases: 6.1, 6.0, 4.7, 4.6, 4.5
Reviewed-on: https://review.typo3.org/17637
Reviewed-by: Oliver Hader
Tested-by: Oliver Hader

History
#1 - 2013-01-11 18:32 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/17468

#2 - 2013-01-12 16:50 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/17468

#3 - 2013-01-12 17:00 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-0 has been pushed to the review server.
It is available at https://review.typo3.org/17496

#4 - 2013-01-12 17:30 - Oliver Hader
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:2abebe67414dbff9b07975d583d1619a78a9fbc5.

#5 - 2013-01-12 18:11 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_4-7 has been pushed to the review server.
It is available at https://review.typo3.org/17497

#6 - 2013-01-21 23:15 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-5 has been pushed to the review server.
It is available at https://review.typo3.org/17637

#7 - 2013-01-21 23:16 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-6 has been pushed to the review server.
It is available at https://review.typo3.org/17638

#8 - 2013-03-15 18:30 - Jigal van Hemert
- Status changed from Under Review to Resolved

Applied in changeset commit:1da948f9ad6ed5dc751cb5439909d1335072fbb7.

#9 - 2013-03-16 11:05 - Oliver Hader

Patch for TYPO3_4-6 has been dropped due to EOL

#10 - 2013-09-25 17:56 - Thorsten Kahler
- Is Regression set to No

The solution causes an issue with the sorting buttons in page module because the colPos is ignored when attaching the sorting information in method 
PageLayoutView::getResult(). (see #48939 and related)

I suggest to revert the patch and use #32967 and #39983 instead.

#11 - 2013-10-25 21:30 - Jigal van Hemert

@Thorsten : the patches you mention do not solve this issue, nor do they solve the problem with the sorting buttons. This particular patch solved the
problem that the content elements from the live workspace were first retrieved for each column and after that the workspace overlay was applied. If the
column was moved to another column in the workspace it was displayed in the column where it was in the live workspace. This patch solves that by
first retrieving the content elements from all columns, applying the workspace overlay and then distribute them to the columns.
The problem in getResult is that it was designed for use in a single column. The solution in https://review.typo3.org/25001 may not be perfect yet, but it
will move the handling of the sorting links data to the right place.

#12 - 2013-10-28 18:38 - Thorsten Kahler

Jigal van Hemert wrote:

This particular patch solved the problem that the content elements from the live workspace were first retrieved for each column and after that the
workspace overlay was applied. If the column was moved to another column in the workspace it was displayed in the column where it was in the
live workspace. This patch solves that by first retrieving the content elements from all columns, applying the workspace overlay and then distribute
them to the columns.

If move placeholders are created when content elements are moved between columns the original code of PageLayoutView works flawless because
    -  placeholder records are fetched in the right column
    -  moved records are detected when applying the WS overlay

If changing the colPos is handled as move operation this doesn't only solve the BE display issue #44470 but also fixes FE preview.

The problem in getResult is that it was designed for use in a single column. The solution in https://review.typo3.org/25001 may not be perfect yet,
but it will move the handling of the sorting links data to the right place.

The (IMO) "perfect" solution would be to use move placeholders consistently. Then there would be no problem with getResult().

Please try to change the column via drag-n-drop and via BE form to see the difference: drag-n-drop already creates a move placeholder.
